
; CC5X Version 3.1I, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  15. Nov 2005  22:15  *************

	processor  16F88
	radix  DEC

INDF        EQU   0x00
PCL         EQU   0x02
FSR         EQU   0x04
PORTA       EQU   0x05
TRISA       EQU   0x85
PORTB       EQU   0x06
TRISB       EQU   0x86
PCLATH      EQU   0x0A
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
IRP         EQU   7
GIE         EQU   7
OPTION_REG  EQU   0x81
TMR1L       EQU   0x0E
TMR1H       EQU   0x0F
RCSTA       EQU   0x18
TXREG       EQU   0x19
RCREG       EQU   0x1A
ADRESH      EQU   0x1E
ADCON0      EQU   0x1F
OSCCON      EQU   0x8F
TXSTA       EQU   0x98
SPBRG       EQU   0x99
ANSEL       EQU   0x9B
ADRESL      EQU   0x9E
ADCON1      EQU   0x9F
EEDATA      EQU   0x10C
EEADR       EQU   0x10D
EEDATH      EQU   0x10E
EEADRH      EQU   0x10F
PEIE        EQU   6
TMR1IF      EQU   0
TXIF        EQU   4
RCIF        EQU   5
TMR1ON      EQU   0
CREN        EQU   4
SPEN        EQU   7
GO          EQU   2
TXIE        EQU   4
RCIE        EQU   5
BRGH        EQU   2
SYNC        EQU   4
TXEN        EQU   5
RD          EQU   0
EEPGD       EQU   7
RX_In       EQU   0x4F
want_ints   EQU   0
want_ints_2 EQU   0
nate        EQU   0x4A
counter     EQU   0x7F
x           EQU   0x4A
nate_2      EQU   0x3A
my_byte     EQU   0x3B
i           EQU   0x3D
k           EQU   0x3E
m           EQU   0x3F
temp        EQU   0x40
high_byte   EQU   0x41
low_byte    EQU   0x42
C1cnt       EQU   0x4A
C2tmp       EQU   0x4B
C3cnt       EQU   0x4A
C4tmp       EQU   0x4B
C5cnt       EQU   0x4A
C6tmp       EQU   0x4B
C7rem       EQU   0x4D
x_2         EQU   0x7F
x_3         EQU   0x3A
y_2         EQU   0x3C
z_2         EQU   0x3D
x_4         EQU   0x7F
y_3         EQU   0x7F
dialed_number EQU   0x20
counter_2   EQU   0x21
number_length EQU   0x23
x_5         EQU   0x24
i_2         EQU   0x20
i_3         EQU   0x22
i_4         EQU   0x20
x_6         EQU   0x7F
number      EQU   0x7F
temp2       EQU   0x7F
temp_3      EQU   0x7F
command_to_send EQU   0x7F
string_to_find EQU   0x7F
response    EQU   0x7F
search_string EQU   0x7F
find_string EQU   0x7F
find_spot   EQU   0x7F
search_spot EQU   0x7F
spot_character EQU   0x7F
search_character EQU   0x7F
dialed_number_2 EQU   0x7F
counter_3   EQU   0x7F
number_length_2 EQU   0x7F
x_7         EQU   0x7F
error_number EQU   0x7F
i_6         EQU   0x7F
ci          EQU   0x4A
ci_2        EQU   0x7F

	GOTO main

  ; FILE C:\Global\Code\Pics\code\16F88\Port-O-Rotary\PortableRotary-v3_1.c
			;/*
			;    1-14-05
			;    Copyright Spark Fun Electronics 2005
			;    
			;    (Nathan Seidle)
			;
			;    Decoding of an old rotary dial telephone with a 16F88
			;    
			;    Uses Bloader/Screamer at 20MHz. Counts the ticks and translates them to the number to dial.
			;    Also detects the on hook/off hook status.
			;    
			;    All inputs are on RB4-7 with weak internal pull-ups.
			;    
			;    Uses onboard UART at 9600.
			;
			;    9-14-05 : (Nathan Seidle) Added support for SIM cards with PIN numbers.
			;    Added scanning of GM862 report strings. Added auto-freq select : Phone
			;    attempts connection on North American frequencies. If no networks are
			;    detected, it will automatically swtich to European Frequencies.
			;    Once the phone is connected, and ready to place and receive calls, it will ring two short rings.
			;
			;    10-25-05 : (Pete Dokter) Updated to work with touch tone pads
			;*/
			;
			;#define Clock_8MHz
			;#define Baud_9600
			;//#define TOUCHTONE     //Uncomment this line to use touch tone key pad
			;//#define DEBUG         //Uncomment this line for extra serial output for debugging
			;
			;#include "\Global\Code\Pics\C\16F88.h"
			;
			;#pragma config |= 0x2910
			;#pragma origin 4
	ORG 0x0004

  ; FILE \Global\Code\Pics\code\Stdio.c
			;/*
			;    5/21/02
			;    Nathan Seidle
			;    nathan.seidle@colorado.edu
			;    
			;    Serial Out Started on 5-21
			;    rs_out Perfected on 5-24
			;    
			;    1Wire Serial Comm works with 4MHz Xtal
			;    Connect Serial_Out to Pin2 on DB9 Serial Connector
			;    Connect Pin5 on DB9 Connector to Signal Ground
			;    9600 Baud 8-N-1
			;    
			;    5-21 My first real C and Pic program.
			;    5-24 Attempting 20MHz implementation
			;    5-25 20MHz works
			;    5-25 Serial In works at 4MHz
			;    5-25 Passing Strings 9:20
			;    5-25 Option Selection 9:45
			;
			;    6-9  'Stdio.c' created. Printf working with %d and %h
			;    7-20 Added a longer delay after rs_out
			;         Trying to get 20MHz on the 16F873 - I think the XTal is bad.
			;         20MHz also needs 5V Vdd. Something I dont have.
			;    2-9-03 Overhauled the 4MHz timing. Serial out works very well now.
			;    
			;    6-16-03 Discovered how to pass string in cc5x
			;        void test(const char *str);
			;        test("zbcdefghij"); TXREG = str[1];
			;        
			;        Moved to hardware UART. Old STDIO will be in goodworks.
			;        
			;        Works great! Even got the special print characters (\n, \r, \0) to work.
			;    
			;    4-25-04 Added new %d routine to print 16 bit signed decimal numbers without leading 0s.
			;        
			;
			;*/
			;
			;//Setup the hardware UART TX module
			;void enable_uart_TX(bit want_ints)
			;{
_const1
	MOVWF ci
	MOVLW .0
	BSF   0x03,RP1
	MOVWF EEADRH
	BCF   0x03,RP1
	RRF   ci,W
	ANDLW .127
	ADDLW .35
	BSF   0x03,RP1
	MOVWF EEADR
	BTFSC 0x03,Carry
	INCF  EEADRH,1
	BSF   0x03,RP0
	BSF   0x18C,EEPGD
	BSF   0x18C,RD
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSC ci,0
	GOTO  m001
	BSF   0x03,RP1
	MOVF  EEDATA,W
	ANDLW .127
	BCF   0x03,RP1
	RETURN
m001	BSF   0x03,RP1
	RLF   EEDATA,W
	RLF   EEDATH,W
	BCF   0x03,RP1
	RETURN
	DW    0x308D
	DW    0x3274
	DW    0x20
	DW    0x2A41
	DW    0x21A3
	DW    0x2841
	DW    0x193D
	DW    0xD
	DW    0x2A41
	DW    0x6C1
	DW    0x3080
	DW    0x3474
	DW    0xD
	DW    0x37D0
	DW    0x3A72
	DW    0x27AD
	DW    0x292D
	DW    0x3A6F
	DW    0x3961
	DW    0x1079
	DW    0x1976
	DW    0x18A0
	DW    0x16B0
	DW    0x1AB2
	DW    0x182D
	DW    0x6B5
	DW    0x2100
	DW    0x37EF
	DW    0x34F4
	DW    0x33EE
	DW    0x172E
	DW    0x6AE
	DW    0x2080
	DW    0x6D4
	DW    0x1580
	DW    0x2843
	DW    0x2749
	DW    0x103A
	DW    0x22D2
	DW    0x2241
	DW    0x59
	DW    0x2A41
	DW    0x21AB
	DW    0x24D0
	DW    0x6CE
	DW    0x1580
	DW    0x2843
	DW    0x2749
	DW    0x103A
	DW    0x24D3
	DW    0x104D
	DW    0x24D0
	DW    0x4E
	DW    0x2A41
	DW    0x2123
	DW    0x224E
	DW    0x18BD
	DW    0xD
	DW    0x2A41
	DW    0x2123
	DW    0x224E
	DW    0x183D
	DW    0xD
	DW    0x2A41
	DW    0x21AB
	DW    0x28D3
	DW    0xD
	DW    0x21AB
	DW    0x28D3
	DW    0x103A
	DW    0x1CB9
	DW    0x1CAC
	DW    0x39
	DW    0x2A41
	DW    0x21A3
	DW    0x2841
	DW    0x18BD
	DW    0xD
	DW    0x2A41
	DW    0x21AB
	DW    0x2B4C
	DW    0x1ECC
	DW    0x6B9
	DW    0x2080
	DW    0x15D4
	DW    0x2843
	DW    0x2749
	DW    0x3D
	DW    0x25CF
	DW    0x0
_const3
	MOVWF ci_2
	BCF   0x03,IRP
	MOVWF FSR
	MOVF  INDF,W
	RETURN
enable_uart_TX
			;    BRGH = 0; //Normal speed UART
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x98,BRGH
			;
			;    SYNC = 0;
	BCF   0x98,SYNC
			;    SPEN = 1;
	BCF   0x03,RP0
	BSF   0x18,SPEN
			;
			;#ifdef Clock_4MHz
			;    #ifdef Baud_9600
			;    SPBRG = 6; //4MHz for 9600 Baud
			;    #endif
			;#endif
			;
			;#ifdef Clock_8MHz
			;    #ifdef Baud_4800
			;    SPBRG = 25; //8MHz for 4800 Baud
			;    #endif
			;    #ifdef Baud_9600
			;    SPBRG = 12; //8MHz for 9600 Baud
	MOVLW .12
	BSF   0x03,RP0
	MOVWF SPBRG
			;    #endif
			;    #ifdef Baud_57600
			;    BRGH = 1; //High speed UART
			;    SPBRG = 7; //8MHz for 57600 Baud
			;    #endif
			;#endif
			;
			;#ifdef Crazy_Osc
			;    #ifdef Baud_9600
			;    SPBRG = 32; //20MHz for 9600 Baud
			;    #endif
			;#endif
			;
			;#ifdef Clock_20MHz
			;    #ifdef Baud_9600
			;    SPBRG = 31; //20MHz for 9600 Baud
			;    #endif
			;
			;    #ifdef Baud_4800
			;    SPBRG = 64; //20MHz for 4800 Baud
			;    #endif
			;#endif
			;
			;    if(want_ints) //Check if we want to turn on interrupts
	BTFSS 0x7F,want_ints
	GOTO  m002
			;    {
			;        TXIE = 1;
	BSF   0x8C,TXIE
			;        PEIE = 1;
	BSF   0x0B,PEIE
			;        GIE = 1;
	BSF   0x0B,GIE
			;    }
			;
			;    TXEN = 1; //Enable transmission
m002	BSF   0x98,TXEN
			;}    
	RETURN
			;
			;//Setup the hardware UART RX module
			;void enable_uart_RX(bit want_ints)
			;{
enable_uart_RX
			;
			;    BRGH = 0; //Normal speed UART
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x98,BRGH
			;
			;    SYNC = 0;
	BCF   0x98,SYNC
			;    SPEN = 1;
	BCF   0x03,RP0
	BSF   0x18,SPEN
			;
			;#ifdef Clock_4MHz
			;    #ifdef Baud_9600
			;    SPBRG = 6; //4MHz for 9600 Baud
			;    #endif
			;#endif
			;
			;#ifdef Clock_8MHz
			;    #ifdef Baud_4800
			;    SPBRG = 25; //8MHz for 4800 Baud
			;    #endif
			;    #ifdef Baud_9600
			;    SPBRG = 12; //8MHz for 9600 Baud
	MOVLW .12
	BSF   0x03,RP0
	MOVWF SPBRG
			;    #endif
			;    #ifdef Baud_57600
			;    BRGH = 1; //High speed UART
			;    SPBRG = 8; //8MHz for 57600 Baud
			;    #endif
			;#endif
			;
			;#ifdef Crazy_Osc
			;    #ifdef Baud_9600
			;    SPBRG = 32; //20MHz for 9600 Baud
			;    #endif
			;#endif
			;
			;#ifdef Clock_20MHz
			;    #ifdef Baud_9600
			;    SPBRG = 31; //20MHz for 9600 Baud
			;    #endif
			;
			;    #ifdef Baud_4800
			;    SPBRG = 64; //20MHz for 4800 Baud
			;    #endif
			;#endif
			;
			;    CREN = 1;
	BCF   0x03,RP0
	BSF   0x18,CREN
			;
			;    //WREN = 1;
			;
			;    if(want_ints) //Check if we want to turn on interrupts
	BTFSS 0x7F,want_ints_2
	GOTO  m003
			;    {
			;        RCIE = 1;
	BSF   0x03,RP0
	BSF   0x8C,RCIE
			;        PEIE = 1;
	BSF   0x0B,PEIE
			;        GIE = 1;
	BSF   0x0B,GIE
			;    }
			;
			;}    
m003	BSF   0x03,RP0
	RETURN
			;
			;//Sends nate to the Transmit Register
			;void putc(uns8 nate)
			;{
putc
	MOVWF nate
			;    while(TXIF == 0);
m004	BTFSS 0x0C,TXIF
	GOTO  m004
			;    TXREG = nate;
	MOVF  nate,W
	MOVWF TXREG
			;}
	RETURN
			;
			;uns8 getc(void)
			;{
getc
			;    while(RCIF == 0);
	BCF   0x03,RP0
	BCF   0x03,RP1
m005	BTFSS 0x0C,RCIF
	GOTO  m005
			;    return (RCREG);
	MOVF  RCREG,W
	RETURN
			;}    
			;
			;uns8 scanc(void)
			;{
scanc
			;    uns16 counter = 0;
	CLRF  counter
	CLRF  counter+1
			;    
			;    //CREN = 0;
			;    //CREN = 1;
			;    
			;    RCIF = 0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x0C,RCIF
			;    while(RCIF == 0)
m006	BTFSC 0x0C,RCIF
	GOTO  m007
			;    {
			;        counter++;
	INCF  counter,1
	BTFSC 0x03,Zero_
	INCF  counter+1,1
			;        if(counter == 1000) return 0;
	MOVF  counter,W
	XORLW .232
	BTFSS 0x03,Zero_
	GOTO  m006
	MOVF  counter+1,W
	XORLW .3
	BTFSS 0x03,Zero_
	GOTO  m006
	RETLW .0
			;    }
			;    
			;    return (RCREG);
m007	MOVF  RCREG,W
	RETURN
			;}    
			;
			;//Returns ASCII Decimal and Hex values
			;uns8 bin2Hex(char x)
			;{
bin2Hex
	MOVWF x
			;   skip(x);
	CLRF  PCLATH
	MOVF  x,W
	ADDWF PCL,1
			;   #pragma return[16] = "0123456789ABCDEF"
	RETLW .48
	RETLW .49
	RETLW .50
	RETLW .51
	RETLW .52
	RETLW .53
	RETLW .54
	RETLW .55
	RETLW .56
	RETLW .57
	RETLW .65
	RETLW .66
	RETLW .67
	RETLW .68
	RETLW .69
	RETLW .70
			;}
			;
			;//Prints a string including variables
			;void printf(const char *nate, int16 my_byte)
			;{
printf
			;  
			;    uns8 i, k, m, temp;
			;    uns8 high_byte = 0, low_byte = 0;
	CLRF  high_byte
	CLRF  low_byte
			;    uns8 y, z;
			;    
			;    uns8 decimal_output[5];
			;    
			;    for(i = 0 ; ; i++)
	CLRF  i
			;    {
			;        //delay_ms(3);
			;        
			;        k = nate[i];
m008	MOVF  i,W
	ADDWF nate_2,W
	CALL  _const1
	MOVWF k
			;
			;        if (k == '\0') 
	MOVF  k,1
	BTFSC 0x03,Zero_
			;            break;
	GOTO  m034
			;
			;        else if (k == '%') //Print var
	XORLW .37
	BTFSS 0x03,Zero_
	GOTO  m032
			;        {
			;            i++;
	INCF  i,1
			;            k = nate[i];
	MOVF  i,W
	ADDWF nate_2,W
	CALL  _const1
	MOVWF k
			;
			;            if (k == '\0') 
	MOVF  k,1
	BTFSC 0x03,Zero_
			;                break;
	GOTO  m034
			;            else if (k == '\\') //Print special characters
	XORLW .92
	BTFSS 0x03,Zero_
	GOTO  m009
			;            {
			;                i++;
	INCF  i,1
			;                k = nate[i];
	MOVF  i,W
	ADDWF nate_2,W
	CALL  _const1
	MOVWF k
			;                
			;                putc(k);
	CALL  putc
			;                
			;
			;            } //End Special Characters
			;            else if (k == 'b') //Print Binary
	GOTO  m033
m009	MOVF  k,W
	XORLW .98
	BTFSS 0x03,Zero_
	GOTO  m014
			;            {
			;                for( m = 0 ; m < 8 ; m++ )
	CLRF  m
m010	MOVLW .8
	SUBWF m,W
	BTFSC 0x03,Carry
	GOTO  m033
			;                {
			;                    if (my_byte.7 == 1) putc('1');
	BTFSS my_byte,7
	GOTO  m011
	MOVLW .49
	CALL  putc
			;                    if (my_byte.7 == 0) putc('0');
m011	BTFSC my_byte,7
	GOTO  m012
	MOVLW .48
	CALL  putc
			;                    if (m == 3) putc(' ');
m012	MOVF  m,W
	XORLW .3
	BTFSS 0x03,Zero_
	GOTO  m013
	MOVLW .32
	CALL  putc
			;                    
			;                    my_byte = my_byte << 1;
m013	BCF   0x03,Carry
	RLF   my_byte,1
	RLF   my_byte+1,1
			;                }
	INCF  m,1
	GOTO  m010
			;            } //End Binary               
			;            else if (k == 'd') //Print Decimal
m014	MOVF  k,W
	XORLW .100
	BTFSS 0x03,Zero_
	GOTO  m028
			;            {
			;                //Print negative sign and take 2's compliment
			;                
			;                if(my_byte < 0)
	BTFSS my_byte+1,7
	GOTO  m017
			;                {
			;                    putc('-');
	MOVLW .45
	CALL  putc
			;                    my_byte *= -1;
	MOVF  my_byte,W
	MOVWF C2tmp
	MOVF  my_byte+1,W
	MOVWF C2tmp+1
	MOVLW .16
	MOVWF C1cnt
m015	BCF   0x03,Carry
	RLF   my_byte,1
	RLF   my_byte+1,1
	RLF   C2tmp,1
	RLF   C2tmp+1,1
	BTFSS 0x03,Carry
	GOTO  m016
	DECF  my_byte+1,1
	DECF  my_byte,1
	INCFSZ my_byte,W
	INCF  my_byte+1,1
m016	DECFSZ C1cnt,1
	GOTO  m015
			;                }
			;                
			;                
			;                if (my_byte == 0)
m017	MOVF  my_byte,W
	IORWF my_byte+1,W
	BTFSS 0x03,Zero_
	GOTO  m018
			;                    putc('0');
	MOVLW .48
	CALL  putc
			;                else
	GOTO  m033
			;                {
			;                    //Divide number by a series of 10s
			;                    for(m = 4 ; my_byte > 0 ; m--)
m018	MOVLW .4
	MOVWF m
m019	BTFSC my_byte+1,7
	GOTO  m026
	MOVF  my_byte,W
	IORWF my_byte+1,W
	BTFSC 0x03,Zero_
	GOTO  m026
			;                    {
			;                        temp = my_byte % (uns16)10;
	MOVF  my_byte,W
	MOVWF C4tmp
	MOVF  my_byte+1,W
	MOVWF C4tmp+1
	CLRF  temp
	MOVLW .16
	MOVWF C3cnt
m020	RLF   C4tmp,1
	RLF   C4tmp+1,1
	RLF   temp,1
	BTFSC 0x03,Carry
	GOTO  m021
	MOVLW .10
	SUBWF temp,W
	BTFSS 0x03,Carry
	GOTO  m022
m021	MOVLW .10
	SUBWF temp,1
m022	DECFSZ C3cnt,1
	GOTO  m020
			;                        decimal_output[m] = temp;
	MOVLW .69
	ADDWF m,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  temp,W
	MOVWF INDF
			;                        my_byte = my_byte / (uns16)10;               
	MOVF  my_byte,W
	MOVWF C6tmp
	MOVF  my_byte+1,W
	MOVWF C6tmp+1
	CLRF  C7rem
	MOVLW .16
	MOVWF C5cnt
m023	RLF   C6tmp,1
	RLF   C6tmp+1,1
	RLF   C7rem,1
	BTFSC 0x03,Carry
	GOTO  m024
	MOVLW .10
	SUBWF C7rem,W
	BTFSS 0x03,Carry
	GOTO  m025
m024	MOVLW .10
	SUBWF C7rem,1
	BSF   0x03,Carry
m025	RLF   my_byte,1
	RLF   my_byte+1,1
	DECFSZ C5cnt,1
	GOTO  m023
			;                    }
	DECF  m,1
	GOTO  m019
			;                
			;                    for(m++ ; m < 5 ; m++)
m026	INCF  m,1
m027	MOVLW .5
	SUBWF m,W
	BTFSC 0x03,Carry
	GOTO  m033
			;                        putc(bin2Hex(decimal_output[m]));
	MOVLW .69
	ADDWF m,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  INDF,W
	CALL  bin2Hex
	CALL  putc
	INCF  m,1
	GOTO  m027
			;                }
			;    
			;            } //End Decimal
			;            else if (k == 'h') //Print Hex
m028	MOVF  k,W
	XORLW .104
	BTFSS 0x03,Zero_
	GOTO  m030
			;            {
			;                //New trick 3-15-04
			;                putc('0');
	MOVLW .48
	CALL  putc
			;                putc('x');
	MOVLW .120
	CALL  putc
			;                
			;                if(my_byte > 0x00FF)
	BTFSC my_byte+1,7
	GOTO  m029
	MOVF  my_byte+1,1
	BTFSC 0x03,Zero_
	GOTO  m029
			;                {
			;                    putc(bin2Hex(my_byte.high8 >> 4));
	SWAPF my_byte+1,W
	ANDLW .15
	CALL  bin2Hex
	CALL  putc
			;                    putc(bin2Hex(my_byte.high8 & 0b.0000.1111));
	MOVLW .15
	ANDWF my_byte+1,W
	CALL  bin2Hex
	CALL  putc
			;                }
			;
			;                putc(bin2Hex(my_byte.low8 >> 4));
m029	SWAPF my_byte,W
	ANDLW .15
	CALL  bin2Hex
	CALL  putc
			;                putc(bin2Hex(my_byte.low8 & 0b.0000.1111));
	MOVLW .15
	ANDWF my_byte,W
	CALL  bin2Hex
	CALL  putc
			;
			;                /*high_byte.3 = my_byte.7;
			;                high_byte.2 = my_byte.6;
			;                high_byte.1 = my_byte.5;
			;                high_byte.0 = my_byte.4;
			;            
			;                low_byte.3 = my_byte.3;
			;                low_byte.2 = my_byte.2;
			;                low_byte.1 = my_byte.1;
			;                low_byte.0 = my_byte.0;
			;        
			;                putc('0');
			;                putc('x');
			;            
			;                putc(bin2Hex(high_byte));
			;                putc(bin2Hex(low_byte));*/
			;            } //End Hex
			;            else if (k == 'f') //Print Float
	GOTO  m033
m030	MOVF  k,W
	XORLW .102
	BTFSS 0x03,Zero_
	GOTO  m031
			;            {
			;                putc('!');
	MOVLW .33
	CALL  putc
			;            } //End Float
			;            else if (k == 'u') //Print Direct Character
	GOTO  m033
m031	MOVF  k,W
	XORLW .117
	BTFSS 0x03,Zero_
	GOTO  m033
			;            {
			;                //All ascii characters below 20 are special and screwy characters
			;                //if(my_byte > 20) 
			;                    putc(my_byte);
	MOVF  my_byte,W
	CALL  putc
			;            } //End Direct
			;                        
			;        } //End Special Chars           
			;
			;        else
	GOTO  m033
			;            putc(k);
m032	MOVF  k,W
	CALL  putc
			;    }    
m033	INCF  i,1
	GOTO  m008
			;}
m034	RETURN

  ; FILE \Global\Code\Pics\code\Delay.c
			;/*
			;    7/23/02
			;    Nathan Seidle
			;    nathan.seidle@colorado.edu
			;    
			;    Delays for... Well, everything.
			;    
			;    11-11 Updated the delays - now they actually delay what they say they should.
			;    
			;    10-11-03 Updated delays. New CC5X compiler is muy optimized.
			;
			;*/
			;
			;//Really short delay
			;void delay_us(uns16 x)
			;{
delay_us
			;
			;#ifdef Clock_4MHz
			;    //Calling with 10us returns 69us
			;    for ( ; x > 0 ; x--);
			;#endif
			;
			;#ifdef Clock_8MHz
			;    //Calling with 1us returns 11us
			;    //Calling with 10us returns 56us
			;    //for ( ; x > 0 ; x--);
			;    
			;    //Calling with 1us returns 7.5us
			;    //Calling with 10us returns 48
			;    //Calling with 1000us returns 4.5ms
			;    while(--x); 
m035	DECF  x_2,1
	INCF  x_2,W
	BTFSC 0x03,Zero_
	DECF  x_2+1,1
	MOVF  x_2,W
	IORWF x_2+1,W
	BTFSS 0x03,Zero_
	GOTO  m035
			;
			;    //while(x--); 
			;#endif
			;
			;#ifdef Clock_9216MHz
			;    //Copied from 8MHz - not tested
			;    while(--x); 
			;#endif
			;
			;#ifdef Clock_10MHz
			;    //delay_us(1) = 6.4us
			;    //delay_us(10) = 16.8us
			;    //delay_us(100) = 110.4us
			;    while(x > 4) x -= 5;
			;#endif
			;
			;#ifdef Clock_20MHz
			;    //Calling with 10us returns 13 us
			;    //Calling with 1us returns 1.8us
			;    while(--x) nop(); 
			;#endif
			;
			;}
	RETURN
			;
			;//General short delay
			;void delay_ms(uns16 x)
			;{
delay_ms
			;
			;#ifdef Clock_4MHz
			;    //Clocks out at 1002us per 1ms
			;    int y;
			;    for ( ; x > 0 ; x--)
			;        for ( y = 0 ; y < 108 ; y++);
			;#endif
			;
			;#ifdef Clock_8MHz
			;    //Clocks out at 1006us per 1ms
			;    uns8 y, z;
			;    for ( ; x > 0 ; x--)
m036	MOVF  x_3,W
	IORWF x_3+1,W
	BTFSC 0x03,Zero_
	GOTO  m041
			;        for ( y = 0 ; y < 4 ; y++)
	CLRF  y_2
m037	MOVLW .4
	SUBWF y_2,W
	BTFSC 0x03,Carry
	GOTO  m040
			;            for ( z = 0 ; z < 69 ; z++);
	CLRF  z_2
m038	MOVLW .69
	SUBWF z_2,W
	BTFSC 0x03,Carry
	GOTO  m039
	INCF  z_2,1
	GOTO  m038
m039	INCF  y_2,1
	GOTO  m037
m040	DECF  x_3,1
	INCF  x_3,W
	BTFSC 0x03,Zero_
	DECF  x_3+1,1
	GOTO  m036
			;#endif
			;
			;#ifdef Clock_9216MHz
			;    //Copied from 8MHz - not tested
			;    uns8 y, z;
			;    for ( ; x > 0 ; x--)
			;        for ( y = 0 ; y < 4 ; y++)
			;            for ( z = 0 ; z < 69 ; z++);
			;#endif
			;
			;#ifdef Clock_10MHz
			;    //delay_ms(1) = 1.006ms
			;    //delay_ms(10) = 10.02ms
			;    //delay_ms(100) = 100.16ms
			;
			;    uns8 y, z;
			;    for ( ; x > 0 ; x--)
			;        for ( y = 0 ; y < 4 ; y++)
			;            for ( z = 0 ; z < 87 ; z++);
			;#endif
			;
			;#ifdef Clock_20MHz
			;
			;    uns8 y, z;
			;    //Clocks out to 1.00ms per 1ms
			;    //9.99 ms per 10ms
			;    for ( ; x > 0 ; x--)
			;        for ( y = 0 ; y < 4 ; y++)
			;            for ( z = 0 ; z < 176 ; z++);
			;#endif
			;
			;}
m041	RETURN
			;
			;//Delays in 31.25kHz Low Power mode using the internal 31.25kHz oscillator
			;void delay_s_lp(uns16 x)
			;{
delay_s_lp
			;
			;    uns16 y;
			;    //Clocks out to 1.001s per 1s
			;    for ( ; x > 0 ; x--)
m042	MOVF  x_4,W
	IORWF x_4+1,W
	BTFSC 0x03,Zero_
	GOTO  m046
			;        for ( y = 0 ; y < 775 ; y++);
	CLRF  y_3
	CLRF  y_3+1
m043	MOVLW .3
	SUBWF y_3+1,W
	BTFSS 0x03,Carry
	GOTO  m044
	BTFSS 0x03,Zero_
	GOTO  m045
	MOVLW .7
	SUBWF y_3,W
	BTFSC 0x03,Carry
	GOTO  m045
m044	INCF  y_3,1
	BTFSC 0x03,Zero_
	INCF  y_3+1,1
	GOTO  m043
m045	DECF  x_4,1
	INCF  x_4,W
	BTFSC 0x03,Zero_
	DECF  x_4+1,1
	GOTO  m042

  ; FILE C:\Global\Code\Pics\code\16F88\Port-O-Rotary\PortableRotary-v3_1.c
			;
			;//Global variable declarations
			;#define HOOK        PORTB.4
			;#define ROTARY      PORTB.6
			;#define END_ROTARY  PORTB.7
			;#define RI          PORTB.0
			;
			;#define GM862_ON    PORTB.3
			;#define STATUS_LED  PORTA.0
			;
			;#define RING1       PORTA.2
			;#define RING2       PORTA.3
			;#define RING_POWER  PORTA.1
			;
			;#define OFF         1
			;#define ON          0
			;
			;#define ERROR1      1
			;#define ERROR2      2
			;#define ERROR3      3
			;#define ERROR4      4
			;#define ERROR5      5
			;#define OK          250
			;#define ERROR       255
			;
			;#define FIFO_SIZE   30
			;
			;uns8 RX_In;
			;uns8 RX_Array[FIFO_SIZE];
			;//End Global variable declarations
			;
			;//Function declarations
			;#include "\Global\Code\Pics\code\Stdio.c" // Basic Serial IO
			;#include "\Global\Code\Pics\code\Delay.c" // Delays
m046	RETURN
			;
			;void incoming_call(void);
			;void place_call(void);
			;void ring_it(void);
			;void short_ring_it(void);
			;uns8 get_TT(void);
			;void boot_up(void);
			;
			;uns8 init_gm862(void);
			;uns8 get_response(const char* command_to_send, const char* string_to_find);
			;uns8 string_compare(const char *search_string, const char *find_string);
			;void error_mode(uns8 error_number);
			;uns8 get_pin(void);
			;//End Function declarations
			;
			;void main()
			;{
main
			;    boot_up();
	BSF   0x03,RP0
	BCF   0x03,RP1
	CALL  boot_up
			;    
			;    while(1)
			;    {
			;        STATUS_LED = OFF;
m047	BSF   PORTA,0
			;
			;        while(HOOK == 0) //Wait for user to lift phone off hook
m048	BTFSC PORTB,4
	GOTO  m051
			;        {
			;            while(RI == 0) //Look for an incoming ring
m049	BTFSC PORTB,0
	GOTO  m050
			;                incoming_call();
	CALL  incoming_call
	GOTO  m049
			;
			;            RING_POWER = OFF; //Power down Ringer
m050	BSF   PORTA,1
			;        }
	GOTO  m048
			;        
			;        if(HOOK == 1) place_call(); //We need to dial out
m051	BTFSS PORTB,4
	GOTO  m047
	CALL  place_call
			;    }
	GOTO  m047
			;
			;}
			;
			;//The phone is off hook so we need to capture the rotary digits and dial the number
			;void place_call(void)
			;{
place_call
			;    uns8 dialed_number, counter, temp;
			;    uns8 number_length;
			;    uns16 x;
			;
			;    uns8 phone_number[20];
			;    
			;    #ifdef DEBUG
			;        printf("Phone is off hook!\n\r Dial: ", 0);
			;    #endif
			;    
			;    
			;    #ifdef TOUCHTONE
			;
			;        //Begin Read Touch Pad
			;        number_length = 0;
			;        
			;        while (1)
			;        {
			;            temp = get_TT();
			;            
			;            if (temp == 0xAA) break;    //user has stopped dialing
			;            else if (temp == 0xFF) return;  //user has hung up
			;            
			;            else
			;            {
			;                phone_number[number_length] = temp;
			;                number_length++;
			;            }
			;        }
			;    
			;    #else
			;
			;        //Begin Read Rotary
			;        number_length = 0;
	CLRF  number_length
			;        
			;        for(counter = 0 ; counter < 30 ; counter++) //Assume we are on a 10-digit dialing type network
	CLRF  counter_2
m052	MOVLW .30
	SUBWF counter_2,W
	BTFSC 0x03,Carry
	GOTO  m066
			;        {
			;            dialed_number = 0;
	CLRF  dialed_number
			;        
			;            //Wait for user to pause up to 4 seconds before sending out the number to the GM862
			;            for(x = 0 ; x < 400 ; x++)
	CLRF  x_5
	CLRF  x_5+1
m053	MOVLW .1
	SUBWF x_5+1,W
	BTFSS 0x03,Carry
	GOTO  m054
	BTFSS 0x03,Zero_
	GOTO  m056
	MOVLW .144
	SUBWF x_5,W
	BTFSC 0x03,Carry
	GOTO  m056
			;            {
			;                delay_ms(10);
m054	MOVLW .10
	MOVWF x_3
	CLRF  x_3+1
	CALL  delay_ms
			;    
			;                if(END_ROTARY == 0) break; //Wait for user to start dialing
	BTFSS PORTB,7
	GOTO  m056
			;                if(HOOK == 0) goto HANG_UP; //If user hangs up,
	BTFSS PORTB,4
	GOTO  m070
			;                
			;                if(number_length == 0) x--; //Wait here indefinitely until the first number is dialed
	MOVF  number_length,1
	BTFSS 0x03,Zero_
	GOTO  m055
	DECF  x_5,1
	INCF  x_5,W
	BTFSC 0x03,Zero_
	DECF  x_5+1,1
			;            }
m055	INCF  x_5,1
	BTFSC 0x03,Zero_
	INCF  x_5+1,1
	GOTO  m053
			;            
			;            if(x == 400 && number_length > 0) goto HARD_DIAL; //We've timed out 4 seconds, time to dial!
m056	MOVF  x_5,W
	XORLW .144
	BTFSS 0x03,Zero_
	GOTO  m057
	DECFSZ x_5+1,W
	GOTO  m057
	MOVF  number_length,1
	BTFSS 0x03,Zero_
	GOTO  m066
			;    
			;            delay_ms(50); //Wait for switch to debounce
m057	MOVLW .50
	MOVWF x_3
	CLRF  x_3+1
	CALL  delay_ms
			;        
			;            while(END_ROTARY == 0 && HOOK == 1)
m058	BTFSC PORTB,7
	GOTO  m063
	BTFSS PORTB,4
	GOTO  m063
			;            {
			;                //Now count how many times the mechnical switch toggles
			;                while(ROTARY == 1) 
m059	BTFSS PORTB,6
	GOTO  m060
			;                    if(END_ROTARY == 1 || HOOK == 0) break;
	BTFSC PORTB,7
	GOTO  m060
	BTFSC PORTB,4
	GOTO  m059
			;    
			;                delay_ms(50); //Wait for switch to debounce
m060	MOVLW .50
	MOVWF x_3
	CLRF  x_3+1
	CALL  delay_ms
			;                STATUS_LED = ON;
	BCF   PORTA,0
			;        
			;                while(ROTARY == 0) 
m061	BTFSC PORTB,6
	GOTO  m062
			;                    if(END_ROTARY == 1 || HOOK == 0) break;
	BTFSC PORTB,7
	GOTO  m062
	BTFSC PORTB,4
	GOTO  m061
			;    
			;                delay_ms(50); //Wait for switch to debounce
m062	MOVLW .50
	MOVWF x_3
	CLRF  x_3+1
	CALL  delay_ms
			;    
			;                STATUS_LED = OFF;
	BSF   PORTA,0
			;        
			;                dialed_number++;
	INCF  dialed_number,1
			;            }
	GOTO  m058
			;        
			;            if(HOOK == 0) goto HANG_UP;
m063	BTFSS PORTB,4
	GOTO  m070
			;    
			;            #ifdef DEBUG
			;                if(HOOK == 0) {printf("Hang up\n\r", 0); break;}
			;            #endif
			;        
			;            dialed_number--; //Rotary always has one extra closure that must be taken off
	DECF  dialed_number,1
			;            
			;            number_length++; //Increase number length by 1 digit
	INCF  number_length,1
			;    
			;            if (dialed_number == 10) dialed_number = 0; //Correct for operator call
	MOVF  dialed_number,W
	XORLW .10
	BTFSC 0x03,Zero_
	CLRF  dialed_number
			;        
			;            if(dialed_number >= 0 && dialed_number <= 9)
	MOVLW .10
	SUBWF dialed_number,W
	BTFSC 0x03,Carry
	GOTO  m064
			;            {
			;                //Store this number into the array
			;                phone_number[counter] = dialed_number + '0';
	MOVLW .38
	ADDWF counter_2,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVLW .48
	ADDWF dialed_number,W
	MOVWF INDF
			;                
			;                #ifdef DEBUG
			;                    printf("%d", dialed_number);
			;    
			;                    if (counter == 2 || counter == 5) printf("-", 0); //Fancy - easier to read
			;                #endif
			;            }
			;            else
	GOTO  m065
			;            {
			;                //Some how we got a bad number - ignore it and try again
			;                counter--;
m064	DECF  counter_2,1
			;    
			;                #ifdef DEBUG
			;                    printf("!", 0); //Error condition
			;                #endif
			;    
			;    
			;            }
			;        }
m065	INCF  counter_2,1
	GOTO  m052
			;        
			;    #endif
			;    
			;    
			;HARD_DIAL:
			;
			;    STATUS_LED = ON;
m066	BCF   PORTA,0
			;    
			;    if(HOOK == 1) //Make sure we still have the phone off hook
	BTFSS PORTB,4
	GOTO  m070
			;    {
			;        //Once we are here, we have the number, time to send it to the cell phone
			;        printf("AT#CAP=2\r", 0); //Turn on handset
	MOVLW .6
	MOVWF nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;        delay_ms(100);
	MOVLW .100
	MOVWF x_3
	CLRF  x_3+1
	CALL  delay_ms
			;
			;        printf("\ratd ", 0);
	CLRF  nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;        for(counter = 0; counter < number_length ; counter++)
	CLRF  counter_2
m067	MOVF  number_length,W
	SUBWF counter_2,W
	BTFSC 0x03,Carry
	GOTO  m068
			;            putc(phone_number[counter]);
	MOVLW .38
	ADDWF counter_2,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  INDF,W
	CALL  putc
	INCF  counter_2,1
	GOTO  m067
			;        putc(';');
m068	MOVLW .59
	CALL  putc
			;        putc('\r'); //The number should now call
	MOVLW .13
	CALL  putc
			;    
			;        while(HOOK == 1); //Wait for user to complete call
m069	BTFSC PORTB,4
	GOTO  m069
			;    }
			;
			;HANG_UP:
			;    printf("ath\r", 0);
m070	MOVLW .21
	MOVWF nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;    delay_ms(1000);
	MOVLW .232
	MOVWF x_3
	MOVLW .3
	MOVWF x_3+1
	CALL  delay_ms
			;
			;    printf("AT#CAP=1\r", 0); //Turn off handset
	MOVLW .146
	MOVWF nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;    delay_ms(100);
	MOVLW .100
	MOVWF x_3
	CLRF  x_3+1
	GOTO  delay_ms
			;    
			;}
			;
			;void incoming_call(void)
			;{
incoming_call
			;    RING_POWER = ON; //Power up Ringer
	BCF   PORTA,1
			;
			;    //Now we need to delay but we need to monitor the hook as well
			;    //Works also as a ringer circuit charger
			;    uns16 i;
			;    for(i = 0 ; i < 300 ; i++)
	CLRF  i_2
	CLRF  i_2+1
m071	MOVLW .1
	SUBWF i_2+1,W
	BTFSS 0x03,Carry
	GOTO  m072
	BTFSS 0x03,Zero_
	GOTO  m073
	MOVLW .44
	SUBWF i_2,W
	BTFSC 0x03,Carry
	GOTO  m073
			;    {
			;        delay_ms(10);
m072	MOVLW .10
	MOVWF x_3
	CLRF  x_3+1
	CALL  delay_ms
			;        if(HOOK == 1) break;
	BTFSC PORTB,4
	GOTO  m073
			;        if(RI == 1) return; //Make sure we still have an incoming call
	BTFSC PORTB,0
	RETURN
			;    }
	INCF  i_2,1
	BTFSC 0x03,Zero_
	INCF  i_2+1,1
	GOTO  m071
			;
			;    ring_it(); //Ring bell for 1.5s
m073	CALL  ring_it
			;    if(RI == 1) return; //Make sure we still have an incoming call
	BTFSC PORTB,0
	RETURN
			;            
			;    //Let us see if we have a call and the hook is off
			;    if(HOOK == 1)
	BTFSS PORTB,4
	GOTO  m075
			;    {
			;        RING_POWER = OFF; //Power down Ringer
	BSF   PORTA,1
			;        
			;        printf("AT#CAP=2\r", 0); //Turn on handset
	MOVLW .6
	MOVWF nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;        delay_ms(100);
	MOVLW .100
	MOVWF x_3
	CLRF  x_3+1
	CALL  delay_ms
			;
			;        printf("ATA\r", 0);
	MOVLW .16
	MOVWF nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;        
			;        while(HOOK == 1); //Wait for user to complete call
m074	BTFSC PORTB,4
	GOTO  m074
			;                
			;        printf("ath\r", 0);
	MOVLW .21
	MOVWF nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;        delay_ms(1000);
	MOVLW .232
	MOVWF x_3
	MOVLW .3
	MOVWF x_3+1
	CALL  delay_ms
			;
			;        printf("AT#CAP=1\r", 0); //Turn off handset
	MOVLW .146
	MOVWF nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;        delay_ms(100);
	MOVLW .100
	MOVWF x_3
	CLRF  x_3+1
	GOTO  delay_ms
			;    }
			;    
			;}
m075	RETURN
			;
			;//Toggle the ring pins at 20Hz or 50ms
			;void ring_it(void)
			;{
ring_it
			;    uns8 i;
			;    
			;    STATUS_LED = ON;
	BCF   PORTA,0
			;
			;    for(i = 0 ; i < 45 ; i++)
	CLRF  i_3
m076	MOVLW .45
	SUBWF i_3,W
	BTFSC 0x03,Carry
	GOTO  m077
			;    {
			;        if(HOOK == 1) break; //We need to monitor the hook
	BTFSC PORTB,4
	GOTO  m077
			;        if(RI == 1) break; //Make sure we still have an incoming call
	BTFSC PORTB,0
	GOTO  m077
			;        RING1 = 1;
	BSF   PORTA,2
			;        RING2 = 0;
	BCF   PORTA,3
			;        delay_ms(20);
	MOVLW .20
	MOVWF x_3
	CLRF  x_3+1
	CALL  delay_ms
			;        
			;        if(HOOK == 1) break; //We need to monitor the hook
	BTFSC PORTB,4
	GOTO  m077
			;        if(RI == 1) break; //Make sure we still have an incoming call
	BTFSC PORTB,0
	GOTO  m077
			;        RING1 = 0;
	BCF   PORTA,2
			;        RING2 = 1;
	BSF   PORTA,3
			;        delay_ms(20);
	MOVLW .20
	MOVWF x_3
	CLRF  x_3+1
	CALL  delay_ms
			;    } 
	INCF  i_3,1
	GOTO  m076
			;
			;    RING1 = 0;
m077	BCF   PORTA,2
			;    RING2 = 0;
	BCF   PORTA,3
			;
			;    STATUS_LED = OFF;
	BSF   PORTA,0
			;}
	RETURN
			;
			;//Toggle the ring pins at 20Hz or 50ms
			;void short_ring_it(void)
			;{
short_ring_it
			;    uns8 i;
			;    
			;    STATUS_LED = ON;
	BCF   PORTA,0
			;
			;    for(i = 0 ; i < 4 ; i++)
	CLRF  i_4
m078	MOVLW .4
	SUBWF i_4,W
	BTFSC 0x03,Carry
	GOTO  m079
			;    {
			;        RING1 = 1;
	BSF   PORTA,2
			;        RING2 = 0;
	BCF   PORTA,3
			;        delay_ms(20);
	MOVLW .20
	MOVWF x_3
	CLRF  x_3+1
	CALL  delay_ms
			;        
			;        RING1 = 0;
	BCF   PORTA,2
			;        RING2 = 1;
	BSF   PORTA,3
			;        delay_ms(20);
	MOVLW .20
	MOVWF x_3
	CLRF  x_3+1
	CALL  delay_ms
			;    } 
	INCF  i_4,1
	GOTO  m078
			;
			;    RING1 = 0;
m079	BCF   PORTA,2
			;    RING2 = 0;
	BCF   PORTA,3
			;
			;    STATUS_LED = OFF;
	BSF   PORTA,0
			;}
	RETURN
			;
			;void boot_up(void)
			;{
boot_up
			;    OSCCON = 0b.0111.0000; //Setup internal oscillator for 8MHz
	MOVLW .112
	MOVWF OSCCON
			;    while(OSCCON.2 == 0); //Wait for frequency to stabilize
m080	BTFSS OSCCON,2
	GOTO  m080
			;    
			;    //Setup Ports
			;    ANSEL = 0b.0000.0000; //Disable ADC on all pins
	CLRF  ANSEL
			;
			;    PORTA = 0b.0000.0000;
	BCF   0x03,RP0
	CLRF  PORTA
			;    TRISA = 0b.0001.1000; //0 = Output, 1 = Input
	MOVLW .24
	BSF   0x03,RP0
	MOVWF TRISA
			;
			;    PORTB = 0b.0000.1001;
	MOVLW .9
	BCF   0x03,RP0
	MOVWF PORTB
			;    TRISB = 0b.1101.0101; //0 = Output, 1 = Input (RX on RB2)
	MOVLW .213
	BSF   0x03,RP0
	MOVWF TRISB
			;
			;    OPTION.7 = 0; //Enable weak pull-ups
	BCF   OPTION_REG,7
			;
			;    //Setup the hardware UART module and interrupts
			;    //=============================================================
			;    SPBRG = 51; //8MHz for 9600 inital communication baud rate
	MOVLW .51
	MOVWF SPBRG
			;    TXSTA = 0b.0010.0100; //8-bit asych mode, high speed uart enabled
	MOVLW .36
	MOVWF TXSTA
			;    RCSTA = 0b.1001.0000; //Serial port enable, 8-bit asych continous receive mode
	MOVLW .144
	BCF   0x03,RP0
	MOVWF RCSTA
			;    //=============================================================
			;
			;    printf("Port-O-Rotary v2 10-25-05\r", 0);
	MOVLW .26
	MOVWF nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;    printf("Booting...\r", 0);
	MOVLW .53
	MOVWF nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;    STATUS_LED = ON;
	BCF   PORTA,0
			;
			;/*
			;    //Ringer test
			;    RING_POWER = ON; //Power up Ringer
			;    uns8 i;
			;    while(1)
			;    {
			;        STATUS_LED = ON;
			;        
			;        for(i = 0 ; i < 45 ; i++)
			;        {
			;            RING1 = 1;
			;            RING2 = 0;
			;            delay_ms(20);
			;            
			;            RING1 = 0;
			;            RING2 = 1;
			;            delay_ms(20);
			;        } 
			;    
			;        RING1 = 0;
			;        RING2 = 0;
			;
			;        STATUS_LED = OFF;
			;        
			;        //RING_POWER = OFF; //Power down Ringer
			;        delay_ms(2000);
			;    }
			;*/    
			;      
			;    RING_POWER = ON; //Power up Ringer
	BCF   PORTA,1
			;
			;    //Turn on GM862
			;    GM862_ON = 0;
	BCF   PORTB,3
			;    delay_ms(1500);
	MOVLW .220
	MOVWF x_3
	MOVLW .5
	MOVWF x_3+1
	CALL  delay_ms
			;    GM862_ON = 1;
	BSF   PORTB,3
			;
			;    //short_ring_it(); //Ring bell for 1.5s
			;    ring_it(); //Ring bell
	CALL  ring_it
			;
			;    delay_ms(9000);
	MOVLW .40
	MOVWF x_3
	MOVLW .35
	MOVWF x_3+1
	CALL  delay_ms
			;
			;    short_ring_it(); //Ring bell for 1.5s
	CALL  short_ring_it
			;    //ring_it(); //Ring bell
			;
			;    RING_POWER = OFF; //Power down Ringer
	BSF   PORTA,1
			;
			;    printf("AT#BND=1\r", 0); //US Canada
	MOVLW .106
	MOVWF nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;    //printf("AT#BND=0\r", 0); //International 
			;    delay_ms(500);
	MOVLW .244
	MOVWF x_3
	MOVLW .1
	MOVWF x_3+1
	CALL  delay_ms
			;    
			;    printf("AT#CAP=1\r", 0); //Turn handset off
	MOVLW .146
	MOVWF nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;    //printf("AT+CLVL=1\r", 0);
			;    delay_ms(500);
	MOVLW .244
	MOVWF x_3
	MOVLW .1
	MOVWF x_3+1
	CALL  delay_ms
			;
			;    printf("AT+CLVL=9\r", 0);
	MOVLW .156
	MOVWF nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;    delay_ms(500);
	MOVLW .244
	MOVWF x_3
	MOVLW .1
	MOVWF x_3+1
	GOTO  delay_ms
			;}
			;
			;//Scan for a button press from a standard 3x4 key pad
			;//Returns one number from the keypad
			;uns8 get_TT(void)   
			;{
get_TT
			;    uns8 x, number, temp2;
			;    uns16 temp;
			;    
			;    x = 0;
	CLRF  x_6
			;    number = 0;
	CLRF  number
			;    temp2 = 0;
	CLRF  temp2
			;    
			;    while(HOOK == 1)
	BCF   0x03,RP0
	BCF   0x03,RP1
m081	BTFSS PORTB,4
	GOTO  m130
			;    {
			;        temp2++;
	INCF  temp2,1
			;        
			;        for (x = 0; x < 4; x++)
	CLRF  x_6
m082	MOVLW .4
	SUBWF x_6,W
	BTFSC 0x03,Carry
	GOTO  m129
			;        {
			;       
			;                temp = 0;       
	CLRF  temp_3
	CLRF  temp_3+1
			;        
			;                ANSEL   = 0b.0111.1000; //set ANS3-6 for analog input
	MOVLW .120
	BSF   0x03,RP0
	MOVWF ANSEL
			;                ADCON1  = 0b.1100.0000; //no Vref
	MOVLW .192
	MOVWF ADCON1
			;                
			;                if (x == 0) ADCON0  = 0b.0001.1001;         //AN3
	MOVF  x_6,1
	BTFSS 0x03,Zero_
	GOTO  m083
	MOVLW .25
	BCF   0x03,RP0
	MOVWF ADCON0
			;                else if (x == 1) ADCON0  = 0b.0010.0001;    //AN4
	GOTO  m086
m083	DECF  x_6,W
	BCF   0x03,RP0
	BTFSS 0x03,Zero_
	GOTO  m084
	MOVLW .33
	MOVWF ADCON0
			;                else if (x == 2) ADCON0  = 0b.0010.1001;    //AN5
	GOTO  m086
m084	MOVF  x_6,W
	XORLW .2
	BTFSS 0x03,Zero_
	GOTO  m085
	MOVLW .41
	MOVWF ADCON0
			;                else if (x == 3) ADCON0  = 0b.0011.0001;    //AN6
	GOTO  m086
m085	MOVF  x_6,W
	XORLW .3
	BTFSS 0x03,Zero_
	GOTO  m086
	MOVLW .49
	MOVWF ADCON0
			;                
			;                //ADCON0  = 0b.0000.0001; //channel 0, AD clock/2       
			;        
			;        
			;                //for (x = 0; x < 50; x++);   //small delay for acqisition...
			;                
			;                TMR1H = 0xCD; TMR1L = 0x00; TMR1IF = 0; TMR1ON = 1; //Setup and turn on hardware timer1
m086	MOVLW .205
	MOVWF TMR1H
	CLRF  TMR1L
	BCF   0x0C,TMR1IF
	BSF   0x10,TMR1ON
			;                while (TMR1IF == 0);
m087	BTFSS 0x0C,TMR1IF
	GOTO  m087
			;                TMR1ON = 0; //Turn off timer1
	BCF   0x10,TMR1ON
			;        
			;                GO = 1;   //start conversion
	BSF   0x1F,GO
			;                while (GO == 1);   //wait for it to finish
m088	BTFSC 0x1F,GO
	GOTO  m088
			;        
			;                temp.low8   = ADRESL;   //read results
	BSF   0x03,RP0
	MOVF  ADRESL,W
	MOVWF temp_3
			;                temp.high8  = ADRESH;
	BCF   0x03,RP0
	MOVF  ADRESH,W
	MOVWF temp_3+1
			;        
			;                if (temp > 10)
	MOVF  temp_3+1,W
	BTFSS 0x03,Zero_
	GOTO  m089
	MOVLW .11
	SUBWF temp_3,W
	BTFSS 0x03,Carry
	GOTO  m128
			;                {
			;                
			;                    if (x == 0)
m089	MOVF  x_6,1
	BTFSS 0x03,Zero_
	GOTO  m097
			;                    {
			;                        if (temp > 900) number = '3';
	MOVLW .3
	SUBWF temp_3+1,W
	BTFSS 0x03,Carry
	GOTO  m091
	BTFSS 0x03,Zero_
	GOTO  m090
	MOVLW .133
	SUBWF temp_3,W
	BTFSS 0x03,Carry
	GOTO  m091
m090	MOVLW .51
	MOVWF number
			;                        else if ((temp > 365) && (temp < 465)) number = '2';
	GOTO  m097
m091	MOVLW .1
	SUBWF temp_3+1,W
	BTFSS 0x03,Carry
	GOTO  m094
	BTFSS 0x03,Zero_
	GOTO  m092
	MOVLW .110
	SUBWF temp_3,W
	BTFSS 0x03,Carry
	GOTO  m094
m092	MOVLW .1
	SUBWF temp_3+1,W
	BTFSS 0x03,Carry
	GOTO  m093
	BTFSS 0x03,Zero_
	GOTO  m094
	MOVLW .209
	SUBWF temp_3,W
	BTFSC 0x03,Carry
	GOTO  m094
m093	MOVLW .50
	MOVWF number
			;                        else if ((temp > 245) && (temp < 345)) number = '1';
	GOTO  m097
m094	MOVF  temp_3+1,W
	BTFSS 0x03,Zero_
	GOTO  m095
	MOVLW .246
	SUBWF temp_3,W
	BTFSS 0x03,Carry
	GOTO  m097
m095	MOVLW .1
	SUBWF temp_3+1,W
	BTFSS 0x03,Carry
	GOTO  m096
	BTFSS 0x03,Zero_
	GOTO  m097
	MOVLW .89
	SUBWF temp_3,W
	BTFSC 0x03,Carry
	GOTO  m097
m096	MOVLW .49
	MOVWF number
			;                    }
			;                
			;                    if (x == 1)
m097	DECFSZ x_6,W
	GOTO  m105
			;                    {
			;                        if (temp > 900) number = '6';
	MOVLW .3
	SUBWF temp_3+1,W
	BTFSS 0x03,Carry
	GOTO  m099
	BTFSS 0x03,Zero_
	GOTO  m098
	MOVLW .133
	SUBWF temp_3,W
	BTFSS 0x03,Carry
	GOTO  m099
m098	MOVLW .54
	MOVWF number
			;                        else if ((temp > 365) && (temp < 465)) number = '5';
	GOTO  m105
m099	MOVLW .1
	SUBWF temp_3+1,W
	BTFSS 0x03,Carry
	GOTO  m102
	BTFSS 0x03,Zero_
	GOTO  m100
	MOVLW .110
	SUBWF temp_3,W
	BTFSS 0x03,Carry
	GOTO  m102
m100	MOVLW .1
	SUBWF temp_3+1,W
	BTFSS 0x03,Carry
	GOTO  m101
	BTFSS 0x03,Zero_
	GOTO  m102
	MOVLW .209
	SUBWF temp_3,W
	BTFSC 0x03,Carry
	GOTO  m102
m101	MOVLW .53
	MOVWF number
			;                        else if ((temp > 245) && (temp < 345)) number = '4';
	GOTO  m105
m102	MOVF  temp_3+1,W
	BTFSS 0x03,Zero_
	GOTO  m103
	MOVLW .246
	SUBWF temp_3,W
	BTFSS 0x03,Carry
	GOTO  m105
m103	MOVLW .1
	SUBWF temp_3+1,W
	BTFSS 0x03,Carry
	GOTO  m104
	BTFSS 0x03,Zero_
	GOTO  m105
	MOVLW .89
	SUBWF temp_3,W
	BTFSC 0x03,Carry
	GOTO  m105
m104	MOVLW .52
	MOVWF number
			;                    }
			;                
			;                    if (x == 3)
m105	MOVF  x_6,W
	XORLW .3
	BTFSS 0x03,Zero_
	GOTO  m114
			;                    {
			;                        if ((temp > 650) && (temp < 750)) number = '9';
	MOVLW .2
	SUBWF temp_3+1,W
	BTFSS 0x03,Carry
	GOTO  m108
	BTFSS 0x03,Zero_
	GOTO  m106
	MOVLW .139
	SUBWF temp_3,W
	BTFSS 0x03,Carry
	GOTO  m108
m106	MOVLW .2
	SUBWF temp_3+1,W
	BTFSS 0x03,Carry
	GOTO  m107
	BTFSS 0x03,Zero_
	GOTO  m108
	MOVLW .238
	SUBWF temp_3,W
	BTFSC 0x03,Carry
	GOTO  m108
m107	MOVLW .57
	MOVWF number
			;                        else if ((temp > 365) && (temp < 465)) number = '8';
	GOTO  m114
m108	MOVLW .1
	SUBWF temp_3+1,W
	BTFSS 0x03,Carry
	GOTO  m111
	BTFSS 0x03,Zero_
	GOTO  m109
	MOVLW .110
	SUBWF temp_3,W
	BTFSS 0x03,Carry
	GOTO  m111
m109	MOVLW .1
	SUBWF temp_3+1,W
	BTFSS 0x03,Carry
	GOTO  m110
	BTFSS 0x03,Zero_
	GOTO  m111
	MOVLW .209
	SUBWF temp_3,W
	BTFSC 0x03,Carry
	GOTO  m111
m110	MOVLW .56
	MOVWF number
			;                        else if ((temp > 245) && (temp < 345)) number = '7';
	GOTO  m114
m111	MOVF  temp_3+1,W
	BTFSS 0x03,Zero_
	GOTO  m112
	MOVLW .246
	SUBWF temp_3,W
	BTFSS 0x03,Carry
	GOTO  m114
m112	MOVLW .1
	SUBWF temp_3+1,W
	BTFSS 0x03,Carry
	GOTO  m113
	BTFSS 0x03,Zero_
	GOTO  m114
	MOVLW .89
	SUBWF temp_3,W
	BTFSC 0x03,Carry
	GOTO  m114
m113	MOVLW .55
	MOVWF number
			;                    }
			;                
			;                    if (x == 2)
m114	MOVF  x_6,W
	XORLW .2
	BTFSS 0x03,Zero_
	GOTO  m123
			;                    {
			;                        if ((temp > 650) && (temp < 750)) number = '#';         //what to do with these...
	MOVLW .2
	SUBWF temp_3+1,W
	BTFSS 0x03,Carry
	GOTO  m117
	BTFSS 0x03,Zero_
	GOTO  m115
	MOVLW .139
	SUBWF temp_3,W
	BTFSS 0x03,Carry
	GOTO  m117
m115	MOVLW .2
	SUBWF temp_3+1,W
	BTFSS 0x03,Carry
	GOTO  m116
	BTFSS 0x03,Zero_
	GOTO  m117
	MOVLW .238
	SUBWF temp_3,W
	BTFSC 0x03,Carry
	GOTO  m117
m116	MOVLW .35
	MOVWF number
			;                        else if ((temp > 365) && (temp < 465)) number = '0';
	GOTO  m123
m117	MOVLW .1
	SUBWF temp_3+1,W
	BTFSS 0x03,Carry
	GOTO  m120
	BTFSS 0x03,Zero_
	GOTO  m118
	MOVLW .110
	SUBWF temp_3,W
	BTFSS 0x03,Carry
	GOTO  m120
m118	MOVLW .1
	SUBWF temp_3+1,W
	BTFSS 0x03,Carry
	GOTO  m119
	BTFSS 0x03,Zero_
	GOTO  m120
	MOVLW .209
	SUBWF temp_3,W
	BTFSC 0x03,Carry
	GOTO  m120
m119	MOVLW .48
	MOVWF number
			;                        else if ((temp > 245) && (temp < 345)) number = '*';    //..............
	GOTO  m123
m120	MOVF  temp_3+1,W
	BTFSS 0x03,Zero_
	GOTO  m121
	MOVLW .246
	SUBWF temp_3,W
	BTFSS 0x03,Carry
	GOTO  m123
m121	MOVLW .1
	SUBWF temp_3+1,W
	BTFSS 0x03,Carry
	GOTO  m122
	BTFSS 0x03,Zero_
	GOTO  m123
	MOVLW .89
	SUBWF temp_3,W
	BTFSC 0x03,Carry
	GOTO  m123
m122	MOVLW .42
	MOVWF number
			;                    }
			;                
			;               
			;                
			;                    while ((temp > 10) && (HOOK == 1))  //wait for the user to lift their finger off the pad or hang up
m123	MOVF  temp_3+1,W
	BTFSS 0x03,Zero_
	GOTO  m124
	MOVLW .11
	SUBWF temp_3,W
	BTFSS 0x03,Carry
	GOTO  m127
m124	BTFSS PORTB,4
	GOTO  m127
			;                    {
			;                        TMR1H = 0xCD; TMR1L = 0x00; TMR1IF = 0; TMR1ON = 1; //Setup and turn on hardware timer1
	MOVLW .205
	MOVWF TMR1H
	CLRF  TMR1L
	BCF   0x0C,TMR1IF
	BSF   0x10,TMR1ON
			;                        while (TMR1IF == 0);
m125	BTFSS 0x0C,TMR1IF
	GOTO  m125
			;                        TMR1ON = 0; //Turn off timer1
	BCF   0x10,TMR1ON
			;        
			;                        GO = 1;   //start conversion
	BSF   0x1F,GO
			;                        while (GO == 1);   //wait for it to finish
m126	BTFSC 0x1F,GO
	GOTO  m126
			;        
			;                        temp.low8   = ADRESL;   //read results
	BSF   0x03,RP0
	MOVF  ADRESL,W
	MOVWF temp_3
			;                        temp.high8  = ADRESH;
	BCF   0x03,RP0
	MOVF  ADRESH,W
	MOVWF temp_3+1
			;                    }
	GOTO  m123
			;                    
			;                    return number;
m127	MOVF  number,W
	RETURN
			;                }
			;            
			;        }
m128	INCF  x_6,1
	GOTO  m082
			;        
			;        if (temp2 >= 200) return 0xAA;     //timeout
m129	MOVLW .200
	SUBWF temp2,W
	BTFSS 0x03,Carry
	GOTO  m081
	RETLW .170
			;        
			;    }
			;    
			;    return 0xFF;        //return something if the user hangs up
m130	RETLW .255
			;}
			;
			;//Powers up and initializes the GM862
			;//Will scan for connection and switch freq if no networks are seen
			;uns8 init_gm862(void)
			;{
init_gm862
			;
			;    RING_POWER = ON; //Power up Ringer
	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   PORTA,1
			;
			;    //Turn on GM862
			;    GM862_ON = 0;
	BCF   PORTB,3
			;    delay_ms(1500);
	MOVLW .220
	MOVWF x_3
	MOVLW .5
	MOVWF x_3+1
	CALL  delay_ms
			;    GM862_ON = 1;
	BSF   PORTB,3
			;
			;    //short_ring_it(); //Ring bell for 1.5s
			;    ring_it(); //Ring bell
	CALL  ring_it
			;
			;    delay_ms(6000);
	MOVLW .112
	MOVWF x_3
	MOVLW .23
	MOVWF x_3+1
	CALL  delay_ms
			;
			;    short_ring_it(); //Ring bell for 1.5s
	CALL  short_ring_it
			;
			;    delay_ms(3000);
	MOVLW .184
	MOVWF x_3
	MOVLW .11
	MOVWF x_3+1
	CALL  delay_ms
			;
			;    STATUS_LED = OFF;
	BSF   PORTA,0
			;
			;    //Clear the incoming array
			;    for(RX_In = 0 ; RX_In < FIFO_SIZE ; RX_In++) RX_Array[RX_In] = 0;
	CLRF  RX_In
m131	MOVLW .30
	SUBWF RX_In,W
	BTFSC 0x03,Carry
	GOTO  m132
	MOVLW .80
	ADDWF RX_In,W
	MOVWF FSR
	BCF   0x03,IRP
	CLRF  INDF
	INCF  RX_In,1
	GOTO  m131
			;    RX_In = 0;
m132	CLRF  RX_In
			;
			;    //Autobaud the unit with the AT command
			;    if(get_response("AT\r", "OK") == ERROR) return ERROR1;
	MOVLW .65
	MOVWF command_to_send
	MOVLW .176
	MOVWF string_to_find
	CALL  get_response
	XORLW .255
	BTFSC 0x03,Zero_
	RETLW .1
			;
			;    //2 - check SIM card status (p12)
			;    //If AT+CPIN<cr> =
			;    //If PIN number is needed, wait for user
			;    //AT+CPIN=****<cr>
			;    if(get_response("AT+CPIN\r", "+CPIN: READY") == ERROR)
	MOVLW .82
	MOVWF command_to_send
	MOVLW .69
	MOVWF string_to_find
	CALL  get_response
	XORLW .255
	BTFSS 0x03,Zero_
	GOTO  m134
			;    {
			;        //If we got an error, let us see if we need a pin number
			;        if(get_response("AT+CPIN\r", "+CPIN: SIM PIN") == OK)
	MOVLW .82
	MOVWF command_to_send
	MOVLW .91
	MOVWF string_to_find
	CALL  get_response
	XORLW .250
	BTFSS 0x03,Zero_
	GOTO  m133
			;        {
			;            //If we do, then wait for the user to dial their pin
			;            short_ring_it(); //Ring bell for 1.5s
	CALL  short_ring_it
			;            delay_ms(500);
	MOVLW .244
	MOVWF x_3
	MOVLW .1
	MOVWF x_3+1
	CALL  delay_ms
			;            short_ring_it(); //Ring bell for 1.5s
	CALL  short_ring_it
			;            delay_ms(500);
	MOVLW .244
	MOVWF x_3
	MOVLW .1
	MOVWF x_3+1
	CALL  delay_ms
			;            short_ring_it(); //Ring bell for 1.5s
	CALL  short_ring_it
			;            delay_ms(500);
	MOVLW .244
	MOVWF x_3
	MOVLW .1
	MOVWF x_3+1
	CALL  delay_ms
			;
			;            STATUS_LED = ON;
	BCF   PORTA,0
			;
			;            if(get_pin() == ERROR) return ERROR2;
	CALL  get_pin
	XORLW .255
	BTFSS 0x03,Zero_
	GOTO  m134
	RETLW .2
			;        }
			;        else //We really do have an error, like no SIM card present
			;            return ERROR2;
m133	RETLW .2
			;    }
			;
			;    //3 - Determine the best band to choose. Either Europe or North America
			;    //Try North America first. If, after 30 seconds, it's the other one, use it.
			;    while(1)
			;    {
			;        //Select North America cellular band
			;        if(get_response("AT#BND=1\r", "OK") == ERROR) return ERROR3;
m134	MOVLW .106
	MOVWF command_to_send
	MOVLW .176
	MOVWF string_to_find
	CALL  get_response
	XORLW .255
	BTFSC 0x03,Zero_
	RETLW .3
			;
			;        delay_ms(10000); //Wait 30 seconds for unit to attach to network
	MOVLW .16
	MOVWF x_3
	MOVLW .39
	MOVWF x_3+1
	CALL  delay_ms
			;        if(get_response("AT+CSQ\r", "+CSQ: 99,99") == ERROR) break; //We assume the response was a signal level, so break
	MOVLW .126
	MOVWF command_to_send
	MOVLW .134
	MOVWF string_to_find
	CALL  get_response
	XORLW .255
	BTFSC 0x03,Zero_
	GOTO  m135
			;
			;        delay_ms(10000); //Wait 30 seconds for unit to attach to network
	MOVLW .16
	MOVWF x_3
	MOVLW .39
	MOVWF x_3+1
	CALL  delay_ms
			;        if(get_response("AT+CSQ\r", "+CSQ: 99,99") == ERROR) break; //We assume the response was a signal level, so break
	MOVLW .126
	MOVWF command_to_send
	MOVLW .134
	MOVWF string_to_find
	CALL  get_response
	XORLW .255
	BTFSC 0x03,Zero_
	GOTO  m135
			;
			;        delay_ms(10000); //Wait 30 seconds for unit to attach to network
	MOVLW .16
	MOVWF x_3
	MOVLW .39
	MOVWF x_3+1
	CALL  delay_ms
			;
			;        if(get_response("AT+CSQ\r", "+CSQ: 99,99") == OK)
	MOVLW .126
	MOVWF command_to_send
	MOVLW .134
	MOVWF string_to_find
	CALL  get_response
	XORLW .250
	BTFSS 0x03,Zero_
	GOTO  m135
			;        {
			;            //If no signal is detected, try the Europe band
			;            if(get_response("AT#BND=0\r", "OK") == ERROR) return ERROR3;
	MOVLW .116
	MOVWF command_to_send
	MOVLW .176
	MOVWF string_to_find
	CALL  get_response
	XORLW .255
	BTFSC 0x03,Zero_
	RETLW .3
			;
			;            delay_ms(10000); //Wait 30 seconds for unit to attach to network
	MOVLW .16
	MOVWF x_3
	MOVLW .39
	MOVWF x_3+1
	CALL  delay_ms
			;            if(get_response("AT+CSQ\r", "+CSQ: 99,99") == ERROR) break; //We assume the response was a signal level, so break
	MOVLW .126
	MOVWF command_to_send
	MOVLW .134
	MOVWF string_to_find
	CALL  get_response
	XORLW .255
	BTFSC 0x03,Zero_
	GOTO  m135
			;
			;            delay_ms(10000); //Wait 30 seconds for unit to attach to network
	MOVLW .16
	MOVWF x_3
	MOVLW .39
	MOVWF x_3+1
	CALL  delay_ms
			;            if(get_response("AT+CSQ\r", "+CSQ: 99,99") == ERROR) break; //We assume the response was a signal level, so break
	MOVLW .126
	MOVWF command_to_send
	MOVLW .134
	MOVWF string_to_find
	CALL  get_response
	XORLW .255
	BTFSC 0x03,Zero_
	GOTO  m135
			;
			;            delay_ms(10000); //Wait 30 seconds for unit to attach to network
	MOVLW .16
	MOVWF x_3
	MOVLW .39
	MOVWF x_3+1
	CALL  delay_ms
			;
			;            if(get_response("AT+CSQ\r", "+CSQ: 99,99") == ERROR) return ERROR3; //If still no signal, then there is an antenna problem
	MOVLW .126
	MOVWF command_to_send
	MOVLW .134
	MOVWF string_to_find
	CALL  get_response
	XORLW .255
	BTFSS 0x03,Zero_
	GOTO  m134
	RETLW .3
			;        }
			;        else
			;            break; //If we get signal, then break the loop
			;    }
			;
			;    //4 -
			;    if(get_response("AT#CAP=1\r", "OK") == ERROR) return ERROR4;
m135	MOVLW .146
	MOVWF command_to_send
	MOVLW .176
	MOVWF string_to_find
	CALL  get_response
	XORLW .255
	BTFSC 0x03,Zero_
	RETLW .4
			;
			;    //5 -
			;    if(get_response("AT+CLVL=9\r", "OK") == ERROR) return ERROR5;
	MOVLW .156
	MOVWF command_to_send
	MOVLW .176
	MOVWF string_to_find
	CALL  get_response
	XORLW .255
	BTFSC 0x03,Zero_
	RETLW .5
			;
			;    //We made it!!! Indicate to the user that the phone is online, ready to use
			;
			;    short_ring_it(); //Ring bell for 1.5s
	CALL  short_ring_it
			;    STATUS_LED = ON;
	BCF   PORTA,0
			;    delay_ms(500);
	MOVLW .244
	MOVWF x_3
	MOVLW .1
	MOVWF x_3+1
	CALL  delay_ms
			;    short_ring_it(); //Ring bell for 1.5s
	CALL  short_ring_it
			;    STATUS_LED = OFF;
	BSF   PORTA,0
			;    delay_ms(500);
	MOVLW .244
	MOVWF x_3
	MOVLW .1
	MOVWF x_3+1
	CALL  delay_ms
			;
			;    RING_POWER = OFF; //Power down Ringer
	BSF   PORTA,1
			;
			;    return OK;
	RETLW .250
			;
			;}
			;
			;//Send a command to the GM862 and wait for a given response
			;//Return error is repsonse is not seen
			;uns8 get_response(const char* command_to_send, const char* string_to_find)
			;{
get_response
			;    uns8 i, response = 0;
	CLRF  response
			;
			;    printf(command_to_send, 0); //Send command to GM862
	MOVF  command_to_send,W
	MOVWF nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;
			;    delay_ms(500); //Absorb everything into the RX array for half second
	MOVLW .244
	MOVWF x_3
	MOVLW .1
	MOVWF x_3+1
	CALL  delay_ms
			;
			;    response = string_compare(RX_Array, string_to_find);
	MOVLW .80
	MOVWF search_string
	MOVF  string_to_find,W
	MOVWF find_string
	CALL  string_compare
	MOVWF response
			;
			;    //Clear the RX Array buffer
			;    for(RX_In = 0 ; RX_In < FIFO_SIZE ; RX_In++) RX_Array[RX_In] = 0;
	CLRF  RX_In
m136	MOVLW .30
	SUBWF RX_In,W
	BTFSC 0x03,Carry
	GOTO  m137
	MOVLW .80
	ADDWF RX_In,W
	MOVWF FSR
	BCF   0x03,IRP
	CLRF  INDF
	INCF  RX_In,1
	GOTO  m136
			;    RX_In = 0; //Reset array position to 0
m137	CLRF  RX_In
			;
			;    return response;
	MOVF  response,W
	RETURN
			;}
			;
			;//Use to find a string within a search string
			;//search : "hithere\0"
			;//find : "the\0" - return OK
			;uns8 string_compare(const char *search_string, const char *find_string)
			;{
string_compare
			;
			;    uns8 find_spot, search_spot;
			;    uns8 spot_character, search_character;
			;    find_spot = 0;
	CLRF  find_spot
			;
			;    for(search_spot = 0 ; ; search_spot++)
	CLRF  search_spot
			;    {
			;        if(find_string[find_spot] == '\0') return OK; //We've reached the end of the search string - that's good!
m138	MOVF  find_spot,W
	ADDWF find_string,W
	CALL  _const1
	XORLW .0
	BTFSC 0x03,Zero_
	RETLW .250
			;        if(search_string[search_spot] == '\0') return ERROR; //End of string found
	MOVF  search_spot,W
	ADDWF search_string,W
	CALL  _const3
	XORLW .0
	BTFSC 0x03,Zero_
	RETLW .255
			;
			;        spot_character = find_string[find_spot]; //Compiler limit
	MOVF  find_spot,W
	ADDWF find_string,W
	CALL  _const1
	MOVWF spot_character
			;        search_character = search_string[search_spot]; //Compiler limit
	MOVF  search_spot,W
	ADDWF search_string,W
	CALL  _const3
	MOVWF search_character
			;
			;        if(spot_character == search_character) //We found another character
	MOVF  spot_character,W
	XORWF search_character,W
	BTFSS 0x03,Zero_
	GOTO  m139
			;            find_spot++; //Look for the next spot in the search string
	INCF  find_spot,1
			;        else if(find_spot > 0) //No character found, so reset the find_spot
	GOTO  m140
m139	MOVF  find_spot,1
	BTFSS 0x03,Zero_
			;            find_spot = 0;
	CLRF  find_spot
			;    }
m140	INCF  search_spot,1
	GOTO  m138
			;
			;    return 0;
			;}
			;
			;//Here we scan the rotary for user input of up to 6 numbers constituting the PIN #
			;//Normally this is 4 numbers, but we can't be sure
			;//Ignore anything the hook might be doing...
			;uns8 get_pin(void)
			;{
get_pin
			;    uns8 dialed_number, counter, temp;
			;    uns8 number_length;
			;    uns16 x;
			;
			;    uns8 phone_number[10];
			;
			;    number_length = 0;
	CLRF  number_length_2
			;
			;    for(counter = 0 ; counter < 10 ; counter++) //Assume we are on a max 10-digit input length
	CLRF  counter_3
m141	MOVLW .10
	SUBWF counter_3,W
	BTFSC 0x03,Carry
	GOTO  m155
			;    {
			;        dialed_number = 0;
	CLRF  dialed_number_2
			;
			;        //Wait for user to pause up to 3 seconds before sending the pin number to the GM862
			;        for(x = 0 ; x < 400 ; x++)
	CLRF  x_7
	CLRF  x_7+1
m142	MOVLW .1
	SUBWF x_7+1,W
	BTFSS 0x03,Carry
	GOTO  m143
	BTFSS 0x03,Zero_
	GOTO  m145
	MOVLW .144
	SUBWF x_7,W
	BTFSC 0x03,Carry
	GOTO  m145
			;        {
			;            delay_ms(10);
m143	MOVLW .10
	MOVWF x_3
	CLRF  x_3+1
	CALL  delay_ms
			;
			;            if(END_ROTARY == 0) break; //Wait for user to start dialing
	BTFSS PORTB,7
	GOTO  m145
			;            //if(HOOK == 0) return ERROR; //If user hangs up,
			;
			;            if(number_length == 0) x--; //Wait here indefinitely until the first number is dialed
	MOVF  number_length_2,1
	BTFSS 0x03,Zero_
	GOTO  m144
	DECF  x_7,1
	INCF  x_7,W
	BTFSC 0x03,Zero_
	DECF  x_7+1,1
			;        }
m144	INCF  x_7,1
	BTFSC 0x03,Zero_
	INCF  x_7+1,1
	GOTO  m142
			;
			;        if(x == 400 && number_length > 0) goto HARD_PIN; //We've timed out to 3 seconds, send PIN to SIM card
m145	MOVF  x_7,W
	XORLW .144
	BTFSS 0x03,Zero_
	GOTO  m146
	DECFSZ x_7+1,W
	GOTO  m146
	MOVF  number_length_2,1
	BTFSS 0x03,Zero_
	GOTO  m155
			;
			;        delay_ms(30); //Wait for switch to debounce
m146	MOVLW .30
	MOVWF x_3
	CLRF  x_3+1
	CALL  delay_ms
			;
			;        while(END_ROTARY == 0) // && HOOK == 1)
m147	BTFSC PORTB,7
	GOTO  m152
			;        {
			;            //Now count how many times the mechnical switch toggles
			;            while(ROTARY == 1)
m148	BTFSS PORTB,6
	GOTO  m149
			;                if(END_ROTARY == 1) break;// || HOOK == 0) break;
	BTFSS PORTB,7
	GOTO  m148
			;
			;            delay_ms(30); //Wait for switch to debounce
m149	MOVLW .30
	MOVWF x_3
	CLRF  x_3+1
	CALL  delay_ms
			;            STATUS_LED = ON;
	BCF   PORTA,0
			;
			;            while(ROTARY == 0)
m150	BTFSC PORTB,6
	GOTO  m151
			;                if(END_ROTARY == 1) break;// || HOOK == 0) break;
	BTFSS PORTB,7
	GOTO  m150
			;
			;            delay_ms(30); //Wait for switch to debounce
m151	MOVLW .30
	MOVWF x_3
	CLRF  x_3+1
	CALL  delay_ms
			;
			;            STATUS_LED = OFF;
	BSF   PORTA,0
			;
			;            dialed_number++;
	INCF  dialed_number_2,1
			;        }
	GOTO  m147
			;
			;        //if(HOOK == 0) return ERROR;
			;
			;        #ifdef DEBUG
			;        //    if(HOOK == 0) {printf("Hang up\n\r", 0); break;}
			;        #endif
			;
			;        dialed_number--; //Rotary always has one extra closure that must be taken off
m152	DECF  dialed_number_2,1
			;
			;        number_length++; //Increase number length by 1 digit
	INCF  number_length_2,1
			;
			;        if (dialed_number == 10) dialed_number = 0; //Correct for operator call
	MOVF  dialed_number_2,W
	XORLW .10
	BTFSC 0x03,Zero_
	CLRF  dialed_number_2
			;
			;        if(dialed_number < 11)
	MOVLW .11
	SUBWF dialed_number_2,W
	BTFSC 0x03,Carry
	GOTO  m153
			;        {
			;            //Store this number into the array
			;            phone_number[counter] = dialed_number + '0';
	MOVLW .127
	ADDWF counter_3,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVLW .48
	ADDWF dialed_number_2,W
	MOVWF INDF
			;
			;            #ifdef DEBUG
			;                printf("%d", dialed_number);
			;
			;                if (counter == 2 || counter == 5) printf("-", 0); //Fancy - easier to read
			;            #endif
			;        }
			;        else
	GOTO  m154
			;        {
			;            //Some how we got a bad number - ignore it and try again
			;            counter--;
m153	DECF  counter_3,1
			;
			;            #ifdef DEBUG
			;                printf("!", 0); //Error condition
			;            #endif
			;        }
			;    }
m154	INCF  counter_3,1
	GOTO  m141
			;
			;HARD_PIN:
			;
			;    STATUS_LED = ON;
m155	BCF   PORTA,0
			;
			;    //if(HOOK == 1) //Make sure we still have the phone off hook
			;    //{
			;        //Once we are here, we have the number, time to send it to the SIM card
			;        printf("AT+CPIN=", 0);
	MOVLW .167
	MOVWF nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;        for(counter = 0; counter < number_length ; counter++)
	CLRF  counter_3
m156	MOVF  number_length_2,W
	SUBWF counter_3,W
	BTFSC 0x03,Carry
	GOTO  m157
			;            putc(phone_number[counter]);
	MOVLW .127
	ADDWF counter_3,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  INDF,W
	CALL  putc
	INCF  counter_3,1
	GOTO  m156
			;
			;        if(get_response("\r", "OK") == ERROR)
m157	MOVLW .14
	MOVWF command_to_send
	MOVLW .176
	MOVWF string_to_find
	CALL  get_response
	XORLW .255
	BTFSC 0x03,Zero_
			;            return ERROR;
	RETLW .255
			;        else
			;        {
			;            //We really should record the PIN number to EEPROM...
			;            STATUS_LED = ON;
	BCF   PORTA,0
			;            delay_ms(500);
	MOVLW .244
	MOVWF x_3
	MOVLW .1
	MOVWF x_3+1
	CALL  delay_ms
			;            STATUS_LED = OFF;
	BSF   PORTA,0
			;            delay_ms(500);
	MOVLW .244
	MOVWF x_3
	MOVLW .1
	MOVWF x_3+1
	CALL  delay_ms
			;            STATUS_LED = ON;
	BCF   PORTA,0
			;            delay_ms(500);
	MOVLW .244
	MOVWF x_3
	MOVLW .1
	MOVWF x_3+1
	CALL  delay_ms
			;            STATUS_LED = OFF;
	BSF   PORTA,0
			;            delay_ms(500);
	MOVLW .244
	MOVWF x_3
	MOVLW .1
	MOVWF x_3+1
	CALL  delay_ms
			;        }
			;
			;        //STATUS_LED = ON;
			;        //while(HOOK == 1); //Wait for user to hang up
			;    //}
			;
			;    return OK;
	RETLW .250
			;}
			;
			;//If we're here, we're screwed, just blink the PIC LED quickly
			;void error_mode(uns8 error_number)
			;{
error_mode
	MOVWF error_number
			;    uns8 i;
			;
			;    while(1)
			;    {
			;        for(i = 0 ; i < error_number ; i++)
	BCF   0x03,RP0
	BCF   0x03,RP1
m158	CLRF  i_6
m159	MOVF  error_number,W
	SUBWF i_6,W
	BTFSC 0x03,Carry
	GOTO  m160
			;        {
			;            STATUS_LED = ON;
	BCF   PORTA,0
			;            delay_ms(200);
	MOVLW .200
	MOVWF x_3
	CLRF  x_3+1
	CALL  delay_ms
			;            STATUS_LED = OFF;
	BSF   PORTA,0
			;            delay_ms(200);
	MOVLW .200
	MOVWF x_3
	CLRF  x_3+1
	CALL  delay_ms
			;        }
	INCF  i_6,1
	GOTO  m159
			;
			;        delay_ms(3000);
m160	MOVLW .184
	MOVWF x_3
	MOVLW .11
	MOVWF x_3+1
	CALL  delay_ms
			;    }
	GOTO  m158

	ORG 0x2007
	DATA 2910H
	END


; *** KEY INFO ***

; 0x00DC P0   16 word(s)  0 % : enable_uart_TX
; 0x00EC P0   19 word(s)  0 % : enable_uart_RX
; 0x00FF P0    6 word(s)  0 % : putc
; 0x0105 P0    6 word(s)  0 % : getc
; 0x010B P0   21 word(s)  1 % : scanc
; 0x0120 P0   20 word(s)  0 % : bin2Hex
; 0x0134 P0  215 word(s) 10 % : printf
; 0x0004 P0  121 word(s)  5 % : _const1
; 0x020B P0    9 word(s)  0 % : delay_us
; 0x0214 P0   24 word(s)  1 % : delay_ms
; 0x022C P0   26 word(s)  1 % : delay_s_lp
; 0x02F2 P0   67 word(s)  3 % : incoming_call
; 0x0256 P0  156 word(s)  7 % : place_call
; 0x0335 P0   32 word(s)  1 % : ring_it
; 0x0355 P0   24 word(s)  1 % : short_ring_it
; 0x03BE P0  361 word(s) 17 % : get_TT
; 0x036D P0   81 word(s)  3 % : boot_up
; 0x0527 P0  212 word(s) 10 % : init_gm862
; 0x05FB P0   32 word(s)  1 % : get_response
; 0x061B P0   33 word(s)  1 % : string_compare
; 0x06CC P0   26 word(s)  1 % : error_mode
; 0x063C P0  144 word(s)  7 % : get_pin
; 0x0246 P0   16 word(s)  0 % : main
; 0x00D7 P0    5 word(s)  0 % : _const3

; RAM usage: 78 bytes (47 local), 290 bytes free
; Maximum call level: 4
;  Codepage 0 has 1763 word(s) :  86 %
;  Codepage 1 has    0 word(s) :   0 %
; Total of 1673 code words (40 %)
